import boxContent from './boxContent';
import Underline from './underline';
import Blank from './blank';
import Composition from './composition';
import Photo from './photo';

let yzComponent = function (cfg) {
  this.parentDom = cfg.content;
  this.boxes = cfg.boxes || [];
  this.boxDom = [];

};

// 添加主键
yzComponent.prototype.addComponent = function () {
  let box = new boxContent();
  box.renderToDom();
  this.parentDom.append(box.vdom);
  this.boxes.push(box);
};

//添加下划线
yzComponent.prototype.addUnderline = function() {
  let underline = new Underline();
  underline.renderToDom();
  this.parentDom.append(underline.vdom);
};

//添加空格
yzComponent.prototype.addBlank = function () {
  let blank = new Blank();
  blank.renderToDom();
  this.parentDom.append(blank.vdom);
};

//添加作文字数
yzComponent.prototype.addComposition = function(words) {
  let composition = new Composition(words);
  composition.renderToDom();
  this.parentDom.append(composition.vdom);
};

// 添加图片
yzComponent.prototype.addPhoto = function (_this) {
  let photo = new Photo({ url: _this.value, dom: _this });
  photo.renderToDom();
  this.parentDom.append(photo.vdom);
};

yzComponent.prototype.renderDom = function() {
  let len = this.boxes.length;
  for(let i = 0;i<len;i++){
    let box = new boxContent(this.boxes[i]);
    box.renderToDom();
    this.parentDom.append(box.vdom);
    this.boxes.push(box);
  }
};

yzComponent.prototype.getBoxes = function() {
  return JSON.stringify(this.boxes);
};

yzComponent.prototype.setContent = function (content)  {
  this.parentDom = content;
};

 export default yzComponent;