/**
 * Create by sxd
 * date 2018-04-11
 * Description:
 */
import $ from 'jquery';

var yzToolbar = function(){
  this.menu = [{
    name: 'blank',
    title: '加空',
    icon: 'fa-square-o'
  },{
    name: 'composition',
    title: '作文格',
    icon: 'fa-table'
  },{
    name: 'underline',
    title: '下划线',
    icon: 'fa-minus'
  },{
    name: 'picture',
    title: '图片',
    icon: 'fa-file-image-o',
  },{
    name: 'component',
    title: '组件框',
    icon: 'fa-object-ungroup'
  },{
    name: 'subject',
    title: '无',
    icon: 'fa-list-alt'
  }];

  // 导航栏的dom;
  this.vdom = null;

  // 问题编号
  this.subjectNum = null;
  // 获取当前需要插入的Dom
  this.currentContent = null;

  this.$dashboard = $('<div class="dashboard" style="max-height: 300px"></div>');

};

yzToolbar.prototype.toolbarContent = function () {
  // 形成toolbar 结构
  let toolDom = document.createElement('div');
  let ulDom = document.createElement('ul');
  this.menu.forEach( (item) => {
    let liDom = document.createElement('li');
    let spanDom = document.createElement('span');
    let liText = document.createTextNode(item.title);
    spanDom.className = `icon fa ${item.icon}`;
    liDom.setAttribute('title',item.title);
    liDom.appendChild(spanDom);
    liDom.appendChild(liText);
    if( item.name == 'component' ){
      liDom.addEventListener('click', () => {
        this.addComponent(liDom);
      },!0);
    }
    if( item.name == 'underline' ){
      liDom.addEventListener('click', () => {
        this.addUnderline();
      },!0);
    }
    if( item.name == 'blank' ){
      liDom.addEventListener('click', () => {
        this.addBlank();
      },!0);
    }
    if( item.name == 'composition' ){
      liDom.addEventListener('click',() => {
        this.addComposition();
      },!0);
    }
    if( item.name == 'picture' ){
      let input = document.createElement('input');
      input.setAttribute('type','file');input.setAttribute('accept','image/png,image/jpeg,image/gif,image/jpg');
      input.style.display = 'none';input.setAttribute('id','uploadPhoto');
      liDom.appendChild(input);
      liDom.addEventListener('click',() => {
        if(this.subjectNum == 'none' || !this.subjectNum){
          alert('请选择主观题');return;
        }
        input.click();
      },!0);
      input.addEventListener('change',(e) => {
        this.addPhoto(input);
      });
    }
    ulDom.appendChild(liDom);
  });
  toolDom.className = 'toolbar';
  toolDom.appendChild(ulDom);
  toolDom.setAttribute('id','toolbar');
  this.removeCompositionNumDom();
  this.vdom = toolDom;
  return toolDom;
};

yzToolbar.prototype.compositionNumDom = function(){
  let table = $('<div class="table-dashboard"><label>作文字数<input class="blank-number" type="number" min="0" step="5" width="80px"></label><button class="submit-btn">添加</button></div>');
  this.$dashboard.append(table);
  $(this.vdom).append(this.$dashboard);
};

yzToolbar.prototype.removeCompositionNumDom = function () {
  this.$dashboard.html('');
};

yzToolbar.prototype.setSubjectTitle = function(pNum,content) {
  this.subjectNum = pNum;
  this.currentContent = content;
  this.menu.forEach( (item) => {
    if( item.name == 'subject' ){
      item.title = '正在编辑' + pNum;
      if( pNum == 'none' ){
        item.title = '无';
      }
    }
  });
};

yzToolbar.prototype.addComponent = function() {
  if(this.subjectNum == 'none' || !this.subjectNum){
    alert('请选择主观题');return;
  }
  this.currentContent.addComponent();
};

yzToolbar.prototype.addUnderline = function() {
  if(this.subjectNum == 'none' || !this.subjectNum){
    alert('请选择主观题');return;
  }
  this.currentContent.addUnderline();
};

yzToolbar.prototype.addBlank = function () {
  if(this.subjectNum == 'none' || !this.subjectNum){
    alert('请选择主观题');return;
  }
  this.currentContent.addBlank();
};

// 添加作文格
yzToolbar.prototype.addComposition = function () {
  if(this.subjectNum == 'none' || !this.subjectNum){
    alert('请选择主观题');return;
  }
  if(this.$dashboard.children().length === 0)this.compositionNumDom();
  this.$dashboard.slideToggle().finish();
  let _this = this;
  $('.submit-btn').on('click', function(e){
    e.stopPropagation();
    _this.currentContent.addComposition($('.blank-number').val());
    $(this).off('click')
  });
};

// 上传图片
yzToolbar.prototype.addPhoto = function (inputDom) {
  this.currentContent.addPhoto(inputDom);
};

export default yzToolbar;